#import "Convert.h"

@implementation Convert : NSObject

+ (id) deviceInfoToObject:(NCDeviceInfo*) deviceInfo {
    NSDictionary* data = [[NSDictionary alloc] init];
    [data setValue: deviceInfo.x forKey:@"x"];
    [data setValue: deviceInfo.y forKey:@"y"];
    [data setValue: deviceInfo.id forKey:@"id"];
    [data setValue: deviceInfo.time forKey:@"time"];
    [data setValue: deviceInfo.time forKey:@"time"];
    [data setValue: [self floatToNSNumber:deviceInfo.r] forKey:@"r"];
    [data setValue: [self floatToNSNumber:deviceInfo.azimuth] forKey:@"azimuth"];
    [data setValue: [self intToNSNumber: deviceInfo.location] forKey:@"location"];
    [data setValue: [self intToNSNumber: deviceInfo.sublocation] forKey:@"subLocation"];
    
    NSMutableArray* paths = [[NSMutableArray alloc] init];
    for (int i = 0; i < [deviceInfo.paths count]; i++) {
        NCRoutePath *path = (NCRoutePath*) [deviceInfo.paths objectAtIndex:i];
        [paths addObject:[self pathToDict:path]];
    }
    [data setValue: paths forKey:@"paths"];
    
    NSMutableArray* zones = [[NSMutableArray alloc] init];
    for (int i = 0; i < [deviceInfo.zones count]; i++) {
        NCZone *zone = (NCZone*) [deviceInfo.zones objectAtIndex:i];
        [zones addObject:[self zoneToDict:zone]];
    }
    [data setValue: zones forKey:@"zones"];
    
    return data;
}

+ (id) pathToDict:(NCRoutePath*) path {
    NSDictionary* pathDict = [[NSDictionary alloc] init];
    // TODO parse this shit too
    
    return pathDict;
}

+ (id) zoneToDict:(NCZone*) zone {
    NSDictionary* pathDict = [[NSDictionary alloc] init];
    // TODO parse this shit too
    
    return pathDict;
}

+ (id) locationInfoToObject:(NCLocation*) location {
    NSDictionary* data = [[NSDictionary alloc] init];
    
    return data;
}

+ (id) floatToNSNumber:(float) f{
    return @(f);
}


+ (id) intToNSNumber:(NSInteger) value{
    return [NSNumber numberWithInteger:value];
}

@end
